<?php

/***************************************************************************
 *                          functions_urlrewrite.php
 *                            -------------------
 *   begin                : Thursday, Dec 2, 2005
 *   version              : Tuesday, May 9, 2006
 *   author               : Yogui
 *   contact              : http://www.thisisnotawebsite.com/forumrnz/ (please do not send emails)
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   Programmer's comments:
 *   This piece of code was a pain to write, so to speak
 *   It is difficult for me to read it now that it is finished, so I bet that
 *   it will be even more difficult for you :/
 *   I followed my usual coding rules but, in order to make the code as
 *   maintainable as possible, I bent them sometimes
 *   For instance, I made extensive use of the "switch" construct.
 *   I even nested it in other structures like "switch" and "if/else"
 *   I just thought it looked better this way
 *   Sorry to the ones who do not like that (I read Roedy Green's article)
 *   If you have a better suggestion, I would be glad to read it
 *
 *   All in all, I hope that it makes sense AND that it is effective
 *
 *
 ***************************************************************************/


define('SITE_FULL_URL', 'http://www.thisisnotawebsite.com/forumrnz/');
define('NEW_EXTENSION', '.htm');    // Replacement file extension (can be '.html', '.php' or whatever you fancy, even an empty string)


/*
* Replace/remove all unwanted characters from a string:
* it builds a string suitable for URLs
* @param    string     $string     The string to rewrite
* @global   array      $lang       The language variables
* @return   string                 The rewritten string
*/
function clean_url_parameter($string){
    global $lang;

    if(!empty($lang['urlrewrite']['boguschars'])){
        $bogus_chars['search'] = $lang['urlrewrite']['boguschars']['search'];
        $bogus_chars['search'] = $lang['urlrewrite']['boguschars']['replacereplace'];
    }
    else{
        $bogus_chars['search']    = array();
        $bogus_chars['replace']   = array();
    }

    $string = str_replace($bogus_chars['search'], $bogus_chars['replace'], strip_tags(html_entity_decode($string)));

    $search    = '';
    $replace   = 'cnaaaaaaaeeeeeeeeeiiiiiiiioooooooouuuuuuuuu';
    $string    = strtr(trim(strtolower($string)), $search, $replace);
    $string    = preg_replace('/[^a-z0-9-]/', '-', $string);
    $string    = trim($string, '-');

    while(strpos($string, '--') !== FALSE){
        $string = str_replace('--', '-', $string);
    }

    return $string;
} //function clean_url_parameter()


/*
* Rewrite the URLs of a phpBB URL
* Needs a working database connection
* @param    string  $old_link['url']    The URL itself
* @param    string  $lang   The language array to use for the translation
* @return   array           The new link: URL and title
*/
function rewrite_url($url, $lang){
    global $db, $board_config; // Useful phpBB variables

    $old_link = array();
    $new_link = array();

    $old_link['url'] = $url;
    $new_link['url'] = $url;
    $parameters_to_avoid    = array('sid'); // Parameters you wish to ignore


    //
    // Get the file name and extension
    //
    if(!preg_match('#([a-z0-9_]+)\.([a-z]+)#si', $old_link['url'], $match)){
        return($new_link); // Didn't find anything to rewrite, skipping the rest of the process
    }
    $old_link['file']   = $match[1];
    $old_link['ext']    = $match[2];


    //
    // Get the path to the linked file
    //
    $old_link['path']    = substr($old_link['url'], 0, strpos($old_link['url'], basename($old_link['url'])));


    //
    // Get anchor, set it to the empty string by default
    //
    if(preg_match('/#([0-9]+)/', $old_link['url'], $match)){
        $old_link['anchor'] = '#'.$match[1];
    }
    else{
        $old_link['anchor'] = '';
    }


    //
    // Split the parameters from the link into an array
    // This will be useful to rebuild the link without having to worry
    // about the order of the parameters in the link
    //
    // Example:
    //  index.php?val2=azerty&val1=qwertz
    // and
    //  index.php?val1=qwertz&val2=azerty
    // are two different strings even though the URLs are the same:
    // with my method, they are treated the same way
    //
    $tmp_url    = $old_link['url'];
    if(!empty($old_link['anchor'])){ //Remove the anchor
        $tmp_url   = substr($old_link['url'], 0, strpos($old_link['url'], $old_link['anchor']));
    }
    $parameters  = array(); // Parameter names will be treated as indexes that store their value
    foreach(preg_split('/[\?&]+/', $tmp_url) as $parameter){
        if(strpos($parameter, '=') !== FALSE){
            list($parameter_name, $parameter_value)    = split('=', $parameter);
            if(!empty($parameter_value) and !in_array($parameter_name, $parameters_to_avoid)){
                if(is_numeric($parameter_value)){
                    $parameters[$parameter_name] = intval($parameter_value);
                }
                else{
                    $parameters[$parameter_name] = addslashes($parameter_value);
                }
            }
        } //if(strpos($parameter, '='))
    } //foreach(preg_split('/[\?&]+/', $link) as $parameter)
    $nb_of_params    = count($parameters);

    //
    // This part will be as long as it is straightforward
    // Its goal is to build the new link, depending on the non-empty parameters
    // originally passed to the script -but not depending on their order
    //
    // In short, we will need to list all the real files for which we want to rewrite
    // URLs, then each combination of their possible parameters
    // With this, we can create the new link
    //
    // Yeah, that's bold but there really is no other way (that I could think of)
    //
    // Actually, it is so boring to do that I will not write it so that it is
    // maintainable code, but possibly efficient instead -remember that
    // URL Rewriting a Web page is a somewhat heavy load process, so it might be
    // a good idea to throw in your optimizing skills here
    //
    // From time to time, I query the database for a title, name or some other thing,
    // but I do not test return values: this is ON PURPOSE! I do not want to have
    // the whole page crash only because the script could not retrieve some unimportant
    // information
    // In any case, the queries are simple enough not to crash too often
    //
    switch($old_link['file']){
        case 'faq': //switch($old_link['file'])
            $default = $old_link['url']; // Defaults to the original link
            switch($nb_of_params){
                case 0: //switch($nb_of_params)
                    $new_link['url']     = $lang['faq'];
                    $new_link['title']   = $lang['titles']['faq'];
                    break; //switch($nb_of_params):case 0

                case 1: //switch($nb_of_params)
                    if(!empty($parameters['mode']) and ($parameters['mode'] == 'bbcode')){
                        $new_link['url']     = $lang['faq_bbcode'];
                        $new_link['title']   = $lang['titles']['faq_bbcode'];
                    }
                    break; //switch($nb_of_params):case 1

                default: //switch($nb_of_params)
                    $new_link['url']    = $default;
            } //switch($nb_of_params)
            break; //switch($old_link['file']):case 'faq'


        case 'groupcp': //switch($file)
            $default   = $old_link['url']; // Defaults to the original link
            switch($nb_of_params){
                case 0: //switch($nb_of_params)
                    $new_link['url']     = $lang['groupcp'];
                    $new_link['title']   = $lang['titles']['groupcp'];
                break; //switch($nb_of_params):case 0

                case 1: //switch($nb_of_params)
                    if(!empty($parameters['g'])){
                        $sql  = 'SELECT `group_name` AS `name`
                                FROM `'.GROUPS_TABLE.'`
                                WHERE `group_id`='.$parameters['g'];

                        if(($result = $db->sql_query($sql)) and ($group = $db->sql_fetchrow($result)) and !empty($group['name'])){
                            $new_link['url']   = sprintf($lang['groupcp_id_name'], $parameters['g'], clean_url_parameter($group['name']));
                            $new_link['title'] = sprintf($lang['titles']['groupcp_name'], $group['name']);
                        }
                        else{
                            $new_link['url']   = $default;
                            $new_link['title'] = $lang['titles']['groupcp'];
                        }
                    }
                    else{
                        $new_link['url']    = $default;
                        $new_link['title']  = $lang['titles']['groupcp'];
                    }
                    break; //switch($nb_of_params):case 1

                default: //switch($parameters['folder'])
                    $new_link['url']     = $default;
                    $new_link['title']   = $lang['titles']['groupcp'];
                    break; //switch($nb_of_params):default
            } //switch($nb_of_params)
            break; //switch($old_link['file']):case 'groupcp'


        case 'index': //switch($old_link['file'])
            $default = $old_link['url']; // Defaults to the original link
            switch($nb_of_params){
                case 0: //switch($nb_of_params)
                    $new_link['url']    = $lang['index'];
                    $new_link['title']  = $lang['titles']['index'];
                    break; //switch($nb_of_params):case 0

                case 1: //switch($nb_of_params)
                    if(!empty($parameters['c'])){
                        $sql  = 'SELECT `cat_title` AS `title`
                            FROM `'.CATEGORIES_TABLE.'`
                            WHERE `cat_id`='.$parameters['c'];

                        if(($result = $db->sql_query($sql)) and ($category = $db->sql_fetchrow($result)) and !empty($category['title'])){
                            $new_link['url']   = sprintf($lang['index_catid_catname'], $parameters['c'], clean_url_parameter($category['title']));
                            $new_link['title'] = sprintf($lang['titles']['index_category'], $category['title']);
                        }
                        else{
                            $new_link['url']  = $default;
                        }
                    }
                    else{
                        if(!empty($parameters['mark'])){
                            $new_link['url']   = $lang['index_markforums'];
                            $new_link['title'] = $lang['titles']['index_markforums'];
                        }
                        else{
                            $new_link['url']  = $default;
                        }
                    }
                    break; //switch($nb_of_params):case 1

                default: //switch($parameters['folder'])
                    $new_link['url']    = $default;
                    break; //switch($nb_of_params):default
            } //switch($nb_of_params)
            break; //switch($old_link['file']):case 'index'


        case 'login': //switch($old_link['file'])
            if(!empty($parameters['logout']) and ($parameters['logout'] == 'true')){
                $new_link['url']     = sprintf($lang['logout'], $userdata['session_id']);
                $new_link['title']   = $lang['titles']['logout'];
            }
            else{
                $new_link['url']     = $lang['login'];
                $new_link['title']   = $lang['titles']['login'];
            }
            break; //switch($old_link['file']):case 'login'


        case 'memberlist': //switch($old_link['file'])
            $default   = $old_link['url']; // Defaults to the original link
            $new_link['title'] = $lang['titles']['memberlist'];
            switch($nb_of_params){
                case 0: //switch($nb_of_params)
                    $new_link['url']    = $lang['memberlist'];
                    break; //switch($nb_of_params):case 0

                case 3: //switch($nb_of_params)
                    if(empty($parameters['mode']) or !empty($parameters['start']) or !empty($parameters['order'])){
                        $new_link['url']    = $default;
                    }
                    else{
                        if(strtolower($parameters['order']) == 'asc'){
                            $new_link['url']  = sprintf($lang['memberlist_mode_start'], $parameters['mode'], $parameters['start']);
                        }
                        else{
                            $new_link['url']  = sprintf($lang['memberlist_mode_start_desc'], $parameters['mode'], $parameters['start']);
                        }
                    }
                    break; //switch($nb_of_params):case 3

                default: //switch($parameters['folder'])
                    $new_link['url']    = $default;
                    break; //switch($nb_of_params):default
            } //switch($nb_of_params)
            break; //switch($old_link['file']):case 'memberlist'


        case 'posting': //switch($old_link['file'])
            $default   = $old_link['url']; // Defaults to the original link
            switch($nb_of_params){
                case 1: //switch($parameters['folder'])
                    if(!empty($parameters['mode']) and ($parameters['mode'] == 'smilies')){
                        $new_link['url']     = $lang['posting_smilies'];
                        $new_link['title']   = $lang['titles']['posting_smilies'];
                    }
                    break; //switch($nb_of_params):case 1

                case 2: //switch($nb_of_params)
                    if(empty($parameters['mode'])){
                        $new_link['url']    = $default;
                    } //if(!empty($parameters['mode']))
                    else{
                        switch($parameters['mode']){
                            case 'newtopic': //switch($parameters['mode'])
                                if(empty($parameters['f'])){
                                    $new_link['url']    = $default;
                                }
                                else{
                                    $sql = 'SELECT `forum_id` AS `id`, `forum_name` AS `name`
                                            FROM `'.FORUMS_TABLE.'`
                                            WHERE `forum_id`='.$parameters['f'];

                                    if(($result  = $db->sql_query($sql)) and ($forum = $db->sql_fetchrow($result)) and !empty($forum['name'])){
                                        $new_link['url']    = sprintf($lang['posting_newtopic'], $forum['id'], clean_url_parameter($forum['name']));
                                        $new_link['title']  = sprintf($lang['titles']['posting_newtopic'], $forum['name']);
                                    }
                                    else{
                                        $new_link['url']    = $default;
                                    }
                                }
                                break; //switch($parameters['mode']):case 'newtopic'

                            case 'reply': //switch($parameters['mode'])
                                if(empty($parameters['t'])){
                                    $new_link['url'] = $default;
                                }
                                else{
                                    $sql = 'SELECT `topic_id` AS `id`, `topic_title` AS `title`
                                        FROM `'.TOPICS_TABLE.'`
                                        WHERE `topic_id`='.$parameters['t'];

                                    if(($result = $db->sql_query($sql)) and ($topic = $db->sql_fetchrow($result)) and !empty($topic['title'])){
                                        $new_link['url']    = sprintf($lang['posting_reply'], $topic['id'], clean_url_parameter($topic['title']));
                                        $new_link['title']  = sprintf($lang['titles']['posting_reply'], $topic['title']);
                                    }
                                    else{
                                        $new_link['url']    = $default;
                                    }
                                }
                                break; //switch($parameters['mode']):case 'reply'

                            case 'quote': //switch($parameters['mode'])
                            case 'editpost': //switch($parameters['mode'])
                                if(empty($parameters['p'])){
                                    $new_link['url'] = $default;
                                }
                                else{
                                    $sql=  'SELECT `post_id` AS `id`, `post_subject` AS `subject`
                                            FROM `'.POSTS_TEXT_TABLE.'`
                                            WHERE `post_id`='.$parameters['p'];

                                    if($result   = $db->sql_query($sql)){
                                        if(($post   = $db->sql_fetchrow($result)) and !empty($post['subject'])){
                                            $new_link['url']    = sprintf($lang['posting_'.$parameters['mode']], $post['id'], clean_url_parameter($post['subject']));
                                            $new_link['title']  = $lang['titles']['posting_'.$parameters['mode']];
                                        }
                                        else{
                                            $sql = 'SELECT p.`post_id` AS `id`, t.`topic_title`
                                                    FROM `'.POSTS_TABLE.'` AS p
                                                    INNER JOIN `'.TOPICS_TABLE.'` AS t ON t.`topic_id` = p.`topic_id`
                                                    WHERE p.`post_id`='.$parameters['p'];

                                            if(($result = $db->sql_query($sql)) and ($post = $db->sql_fetchrow($result)) and !empty($post['topic_title'])){
                                                $new_link['url']    = sprintf($lang['posting_'.$parameters['mode']], $post['id'], clean_url_parameter($post['topic_title']));
                                                $new_link['title']  = $lang['titles']['posting_'.$parameters['mode']];
                                            }
                                        }
                                    }
                                }
                                break; //switch($parameters['mode']):case 'editpost'

                            default:
                                $new_link['url'] = $default;
                                break; //switch($parameters['mode']):default
                        } //switch($parameters['mode'])
                    } //else:if(empty($parameters['mode']))
                    break; //switch($nb_of_params):case 2

                default: //switch($nb_of_params)
                    $new_link['url'] = $default;
                    break; //switch($nb_of_params):default
            } //switch($nb_of_params)
            break; //switch($old_link['file']):case 'posting'


        case 'privmsg': //switch($old_link['file'])
            $default = $old_link['url']; // Defaults to the original link
            switch($nb_of_params){
                case 1: //switch($nb_of_params)
                    if(!empty($parameters['mode']) and ($parameters['mode'] == 'post')){
                        $new_link['url']    = $lang['privmsg_post'];
                        $new_link['title']  = $lang['titles']['privmsg_post'];
                    }
                    else{
                        if(empty($parameters['folder'])){
                            $new_link['url']  = $default;
                        }
                        else{
                            switch($parameters['folder']){
                                case 'inbox':
                                case 'outbox':
                                case 'sentbox':
                                case 'savebox':
                                    $new_link['url']   = $lang[$parameters['folder']];
                                    $new_link['title'] = $lang['titles'][$parameters['folder']];
                                    break;

                                default:
                                    $new_link['url']  = $default;
                                    break;
                            }
                        } //else:if(empty($parameters['folder']))
                    } //else:if(!empty($parameters['mode']) and ($parameters['mode'] == 'post'))
                    break; //switch($nb_of_params):case 1

                case 2: //switch($nb_of_params)
                    if(empty($parameters['mode'])){
                        $new_link['url']    = $default;
                    }
                    else{
                        switch($parameters['mode']){
                            case 'post':
                                if(!empty($parameters['u'])){
                                    $sql  = 'SELECT `username` AS `name`
                                            FROM `'.USERS_TABLE.'`
                                            WHERE `user_id`='.$parameters['u'];

                                    if(($result = $db->sql_query($sql)) and ($user = $db->sql_fetchrow($result)) and !empty($user['name'])){
                                        $new_link['url']    = sprintf($lang['privmsg_post_username'], $parameters['u'], clean_url_parameter($user['name']));
                                        $new_link['title']  = sprintf($lang['titles']['privmsg_post_username'], $user['name']);
                                    }
                                    else{
                                        $new_link['url']    = $default;
                                    }
                                }
                                else{
                                    $new_link['url']    = $default;
                                }
                                break;

                            case 'quote':
                            case 'edit':
                            case 'reply':
                                if(!empty($parameters['p'])){
                                    $sql  = 'SELECT `privmsgs_id` AS `id`, `privmsgs_subject` AS `subject`
                                            FROM `'.PRIVMSGS_TABLE.'`
                                            WHERE `privmsgs_id`='.$parameters['p'];

                                    if(($result  = $db->sql_query($sql)) and ($privmsg = $db->sql_fetchrow($result)) and !empty($privmsg['subject'])){
                                        $new_link['url']    = sprintf($lang['privmsg_'.$parameters['mode']], $privmsg['id'], clean_url_parameter($privmsg['subject']));
                                        $new_link['title']  = sprintf($lang['titles']['privmsg_'.$parameters['mode']], $privmsg['subject']);
                                    }
                                    else{
                                        $new_link['url']    = $default;
                                    }
                                }
                                else{
                                    $new_link['url']    = $default;
                                }
                                break;

                            default:
                                $new_link['url'] = $default;
                                break;
                        } //switch($parameters['mode'])
                    } //else:if(!empty($parameters['mode']))
                    break; //switch($nb_of_params):case 2

                case 3: //switch($nb_of_params)
                    if(empty($parameters['folder'])){
                        $new_link['url']    = $default;
                    }
                    else{
                        switch($parameters['folder']){
                            case 'inbox':
                            case 'outbox':
                            case 'sentbox':
                            case 'savebox':
                                if(!empty($parameters['start'])){
                                    $new_link['url']    = sprintf($lang[$parameters['folder'].'_start'], $parameters['start']);
                                    $new_link['title']  = $lang['titles'][$parameters['folder']];
                                }
                                else{
                                    if(empty($parameters['p'])){
                                        $new_link['url']    = $default;
                                        $new_link['title']  = $lang['titles'][$parameters['folder']];
                                    }
                                    else{
                                        if(empty($parameters['mode'])){
                                            $new_link['url']  = $default;
                                            $new_link['title'] = $lang['titles'][$parameters['folder']];
                                        }
                                        else{
                                            $sql  = 'SELECT `privmsgs_id` AS `id`, `privmsgs_subject` AS `subject`
                                                    FROM `'.PRIVMSGS_TABLE.'`
                                                    WHERE `privmsgs_id`='.$parameters['p'];

                                            if(($result    = $db->sql_query($sql)) and ($privmsg = $db->sql_fetchrow($result)) and !empty($privmsg['subject'])){
                                                $new_link['url']   = sprintf($lang[$parameters['folder'].'_id_title'], $privmsg['id'], clean_url_parameter($privmsg['subject']));
                                                $new_link['title'] = sprintf($lang['titles'][$parameters['folder'].'_title'], $privmsg['subject']);
                                            }
                                            else{
                                                $new_link['url']   = $default;
                                                $new_link['title'] = $lang['titles'][$parameters['folder']];
                                            }
                                        }
                                    }
                                }
                                break;

                            default:
                                $new_link['url'] = $default;
                                break;
                        } //switch($parameters['folder'])
                    } //else:if(empty($parameters['folder']))
                    break; //switch($nb_of_params):case 3

                default: //switch($nb_of_params)
                    $new_link['url']    = $default;
                    break; //switch($nb_of_params):default
            } //switch($nb_of_params)
            break; //switch($old_link['file']):case 'privmsg'


        case 'profile': //switch($old_link['file'])
            $default   = $old_link['url']; // Defaults to the original link
            switch($nb_of_params){
                case 1: //switch($nb_of_params)
                    if(empty($parameters['mode'])){
                        $new_link['url']    = $default;
                    }
                    else{
                        switch($parameters['mode']){
                            case 'editprofile':
                            case 'register':
                            case 'sendpassword':
                                $new_link['url']     = $lang[$parameters['mode']];
                                $new_link['title']   = $lang['titles'][$parameters['mode']];
                                break;

                            default:
                                $new_link['url'] = $default;
                                break;
                        }
                    }
                    break; //switch($nb_of_params):case 1

                case 2: //switch($nb_of_params)
                    if(!empty($parameters['mode']) and !empty($parameters['u']) and (in_array($parameters['mode'], array('viewprofile', 'email')))){
                        $sql  = 'SELECT `username` AS `name`
                                FROM `'.USERS_TABLE.'`
                                WHERE `user_id`='.$parameters['u'];

                        if(($result = $db->sql_query($sql)) and ($user = $db->sql_fetchrow($result)) and !empty($user['name'])){
                            $new_link['url']   = sprintf($lang[$parameters['mode']], $parameters['u'], clean_url_parameter($user['name']));
                            $new_link['title'] = sprintf($lang['titles'][$parameters['mode']], $user['name']);
                        }
                        else{
                            $new_link['url']  = $default;
                        }
                    }
                    else{
                        $new_link['url']    = $default;
                    }
                    break; //switch($nb_of_params):case 2

                default: //switch($nb_of_params)
                    $new_link['url']    = $default;
                    break; //switch($nb_of_params):default
            } //switch($nb_of_params)
            break; //switch($old_link['file']):case 'profile'


        case 'search': //switch($old_link['file'])
            $default   = $old_link['url']; // Defaults to the original link
            switch($nb_of_params){
                case 0: //switch($nb_of_params)
                    $new_link['url']     = $lang['search'];
                    $new_link['title']   = $lang['titles']['search'];
                    break; //switch($nb_of_params):case 0

                case 1: //switch($nb_of_params)
                    if(!empty($parameters['search_author'])){
                        if(!is_numeric($parameters['search_author'])){
                            $sql  = 'SELECT `user_id` AS `id`, `username` AS `name`
                                    FROM `'.USERS_TABLE.'`
                                    WHERE `username`="'.addslashes($parameters['search_author']).'"';

                            if(($result = $db->sql_query($sql)) and ($user = $db->sql_fetchrow($result)) and !empty($user['name'])){
                                $new_link['url']   = sprintf($lang['search_author_name'], clean_url_parameter($user['name']));
                                $new_link['title'] = sprintf($lang['titles']['search_author'], $user['name']);
                            }
                            else{
                                $new_link['url'] = $default;
                                }
                        }
                        else{
                            $sql  = 'SELECT `user_id` AS `id`, `username` AS `name`
                                    FROM `'.USERS_TABLE.'`
                                    WHERE `user_id`='.intval($parameters['search_author']);

                            if(($result = $db->sql_query($sql)) and ($user = $db->sql_fetchrow($result)) and !empty($user['name'])){
                                $new_link['url']  = sprintf($lang['search_author_id'], $user['id'], clean_url_parameter($user['name']));
                                $new_link['title'] = sprintf($lang['titles']['search_author'], $user['name']);
                            }
                            else{
                                $new_link['url'] = $default;
                            }
                        }
                    }
                    else if(!empty($parameters['search_id'])){
                        $new_link['url']    = sprintf($lang[$parameters['search_id']]);
                        $new_link['title']  = $lang['titles']['search'];
                    }
                    else if(!empty($parameters['mode'])){
                        $new_link['url']    = sprintf($lang['search_mode'], $parameters['mode']);
                        $new_link['title']  = $lang['titles']['search'];
                    }
                    else{
                        $new_link['url']  = $default;
                    }
                    break; //switch($nb_of_params):case 1

                default: //switch($nb_of_params)
                    $new_link['url']    = $default;
                    break; //switch($nb_of_params):default
            } //switch($nb_of_params)
            break; //switch($old_link['file']):case 'search'


        case 'statistics': //switch($old_link['file'])
            $default   = $old_link['url']; // Defaults to the original link
            switch($nb_of_params){
                case 0: //switch($nb_of_params)
                    $new_link['url']    = $lang['statistics'];
                    $new_link['title']  = $lang['titles']['statistics'];
                break; //switch($nb_of_params):case 0

            default: //switch($nb_of_params)
                $new_link['url']    = $default;
                break; //switch($nb_of_params):default
            } //switch($nb_of_params)
            break; //switch($old_link['file']):case 'statistics'


        case 'viewforum': //switch($old_link['file'])
            $default   = $old_link['url']; // Defaults to the original link
            //
            // I hate to duplicate code, so here is the SQL
            //
            if(!empty($parameters['f'])){
                if(!empty($userdata['user_level']) and ($userdata['user_level'] == ADMIN)){
                    //
                    // The admins can see the keywords whatever the case
                    //
                    $sql  = 'SELECT `forum_name` AS `name`
                            FROM `'.FORUMS_TABLE.'`
                            WHERE `forum_id`='.$parameters['f'];

                    if(($result  = $db->sql_query($sql)) and ($db->sql_numrows($result) == 1)){
                        $forum   = $db->sql_fetchrow($result);
                    }
                }
                else{
                    //
                    // The user is no admin but maybe the forum can be read by anyone
                    //
                    $sql  = 'SELECT `forum_name` AS `name`
                            FROM `'.FORUMS_TABLE.'`
                            WHERE `forum_id`='.$parameters['f'].'
                                AND `auth_view`=0';

                    if(($result  = $db->sql_query($sql)) and ($db->sql_numrows($result) == 1)){
                        $forum   = $db->sql_fetchrow($result);
                    }
                    else{
                        //
                        // The user is no admin and the forum is private
                        // Maybe the user belongs to a group that has access to this forum
                        //
                        $sql = 'SELECT f.`forum_name` AS `name`
                                FROM `'.FORUMS_TABLE.'` AS f
                                INNER JOIN `'.USER_GROUP_TABLE.'` AS ug ON ug.`user_id`=t.`topic_poster`
                                INNER JOIN `'.AUTH_ACCESS_TABLE.'` AS aa ON aa.`group_id`=ug.`group_id`
                                    AND f.`forum_id`=aa.`forum_id`
                                WHERE `forum_id`='.$parameters['f'].'
                                    AND `auth_view`=1';

                        if(($result2   = $db->sql_query($sql)) and ($db->sql_numrows($result2) == 1)){
                            $forum     = $db->sql_fetchrow($result2);
                        }
                    }
                }

                if(empty($forum)){
                    $new_link['url']    = $default;
                    continue;
                }

                $new_link['title']    = sprintf($lang['titles']['viewforum'], $forum['name']);
            }

            switch($nb_of_params){
                case 1: //switch($nb_of_params)
                    if(empty($parameters['f'])){
                        $new_link['url']    = $default;
                    }
                    else{
                        $new_link['url']    = sprintf($lang['viewforum_id_name'], $parameters['f'], clean_url_parameter($forum['name']));
                    }
                    break; //switch($nb_of_params):case 1

                case 2: //switch($nb_of_params)
                    if(empty($parameters['f'])){
                        $new_link['url']    = $default;
                    }
                    else if(!empty($parameters['mark'])){
                        $new_link['url']    = sprintf($lang['markforum_id_name'], $parameters['f'], clean_url_parameter($forum['name']));
                    }
                    else if(!empty($parameters['start'])){
                        $new_link['url']    = sprintf($lang['viewforum_id_start_name'], $parameters['f'], $parameters['start'], clean_url_parameter($forum['name']));
                    }
                    else{
                        $new_link['url']    = $default;
                    }
                    break; //switch($nb_of_params):case 2

                case 3: //switch($nb_of_params)
                    if(!empty($parameters['f']) and !empty($parameters['topicdays']) and !empty($parameters['start'])){
                        $new_link['url']    = sprintf($lang['viewforum_id_days_start_name'], $parameters['f'], $parameters['topicdays'], $parameters['start'], clean_url_parameter($forum['name']));
                    }
                    else{
                        $new_link['url']    = $default;
                    }
                    break; //switch($nb_of_params):case 3

                default: //switch($nb_of_params)
                    $new_link['url']    = $default;
                    break; //switch($nb_of_params):default
            } //switch($nb_of_params)
            break; //switch($old_link['file']):case 'viewforum'


        case 'viewonline': //switch($old_link['file'])
            $default   = $old_link['url']; // Defaults to the original link
            switch($nb_of_params){
                case 0: //switch($nb_of_params)
                    $new_link['url']    = $lang['viewonline'];
                    $new_link['title']  = $lang['titles']['viewonline'];
                    break; //switch($nb_of_params):case 0

                default: //switch($nb_of_params)
                    $new_link['url']    = $default;
                    break; //switch($nb_of_params):default
            } //switch($nb_of_params)
            break; //switch($old_link['file']):case 'viewonline'


        case 'viewtopic': //switch($old_link['file'])
            $default   = $old_link['url']; // Defaults to the original link
            //
            // If there is no highlighting parameter in the current link, maybe there was
            // in a previous link: this is the workaround I commented about earlier
            // (the 'highlight' parameter is the same for all the links of the page anyway)
            //
            if(!empty($parameters['highlight']) and empty($highlight)){
                $highlight    = $parameters['highlight'];
            }
            else if(empty($parameters['highlight']) and !empty($highlight) and ($nb_of_params === 2)){
                ++$nb_of_params;
            }

            //
            // I hate to duplicate code, so here is the SQL
            //
            if(!empty($parameters['t'])){
                $sql  = 'SELECT `topic_id` AS `id`,
                    `topic_title` AS `title`,
                    `topic_time` AS `time`,
                    `topic_type` AS `type`,
                    `forum_id`
                FROM `'.TOPICS_TABLE.'`
                WHERE `topic_id`='.$parameters['t'];

                if(!($result  = $db->sql_query($sql)) or ($db->sql_numrows($result) == 0)){
                    $new_link['url'] = $default;
                    continue;
                }

                if(($topic    = $db->sql_fetchrow($result)) and !empty($topic['title'])){
                    $new_link['title']  = sprintf($lang['titles']['viewtopic'], $topic['title']);
                }
            }

            switch($nb_of_params){
                case 1: //switch($nb_of_params)
                    if(!empty($parameters['t'])){
                        $new_link['url']    = sprintf($lang['viewtopic_topicid_title'], $topic['id'], clean_url_parameter($topic['title']));
                    } //if(empty($parameters['t']))
                    else if(empty($parameters['p'])){
                        $new_link['url']    = $default;
                    }
                    else{
                        //
                        // The subject of the post might differ from the topic title (or worse: be empty)
                        // Thus and to avoid different links from pointing to the exact same page, we will
                        // display the topic title every time
                        //
                        $sql  = 'SELECT `topic_id`
                                FROM `'.POSTS_TABLE.'`
                                WHERE `post_id`='.$parameters['p'];

                        if(!($result    = $db->sql_query($sql)) or ($db->sql_numrows($result) == 0)){
                            $new_link['url']    = $default;
                            continue;
                        }

                        if(($post   = $db->sql_fetchrow($result)) and !empty($post['topic_id'])){
                            //
                            // Watch out here: you don't want to display the title of a private topic to your guests!
                            // Imagine a private board that everybody can see but that only a few can actually read:
                            // we need to ensure that guests can't see the keywords (we keep harmless links)
                            //
                            $topic  = NULL;
                            if(!empty($userdata['user_level']) and ($userdata['user_level'] == ADMIN)){
                                //
                                // The admins can see the keywords whatever the case
                                //
                                $sql  = 'SELECT `topic_id` AS `id`, `topic_title` AS `title`
                                        FROM `'.TOPICS_TABLE.'`
                                        WHERE `topic_id`='.$post['topic_id'];

                                if(($result  = $db->sql_query($sql)) and ($db->sql_numrows($result) == 1)){
                                    $topic   = $db->sql_fetchrow($result);
                                }
                            }
                            else{
                                //
                                // The user is no admin but maybe the forum can be read by anyone
                                //
                                $sql  = 'SELECT t.`topic_id` AS `id`, t.`topic_title` AS `title`
                                        FROM `'.TOPICS_TABLE.'` AS t
                                        INNER JOIN `'.FORUMS_TABLE.'` AS f ON t.`forum_id`=f.`forum_id`
                                        WHERE t.`topic_id`='.$post['topic_id'].'
                                            AND f.`auth_read` = 0';

                                if(($result   = $db->sql_query($sql)) and ($db->sql_numrows($result) == 1)){
                                    $topic    = $db->sql_fetchrow($result);
                                }
                                else{
                                    //
                                    // The user is no admin and the forum is private
                                    // Maybe the user belongs to a group that has access to this forum
                                    //
                                    $sql = 'SELECT DISTINCT t.`topic_id` AS `id`, t.`topic_title` AS `title`
                                            FROM `'.TOPICS_TABLE.'` AS t
                                            INNER JOIN `'.FORUMS_TABLE.'` AS f ON t.`forum_id`=f.`forum_id`
                                            INNER JOIN `'.USER_GROUP_TABLE.'` AS ug ON ug.`user_id`=t.`topic_poster`
                                            INNER JOIN `'.AUTH_ACCESS_TABLE.'` AS aa ON aa.`group_id`=ug.`group_id`
                                                AND f.`forum_id`=aa.`forum_id`
                                            WHERE t.`topic_id`='.$post['topic_id'].'
                                                AND ug.`user_id`='.$userdata['user_id'].'
                                                AND aa.`auth_read`=1';

                                    if(($result2  = $db->sql_query($sql)) and ($db->sql_numrows($result2) == 1)){
                                        $topic    = $db->sql_fetchrow($result2);
                                    }
                                }
                            }
                        }

                        if(empty($topic)){
                            $new_link['url']  = $default;
                        }
                        else{
                            //
                            // Many topics have several pages
                            // So as not to lose this piece of information (which would lead us
                            // to always build a link to the first page of the topic), we can
                            // compare the number of posts before the one which ID we have to
                            // the number of posts per page (board setting)
                            //
                            $sql = 'SELECT COUNT(*) AS `nb_of_posts`
                                    FROM `'.POSTS_TABLE.'`
                                    WHERE `topic_id`='.$topic['id'].'
                                        AND `post_id`<='.$parameters['p'];

                            if(($result    = $db->sql_query($sql)) and ($db->sql_numrows($result) == 1)){
                                $tmp  = $db->sql_fetchrow($result);
                                $posts_before = $tmp['nb_of_posts'];

                                if($posts_before <= $board_config['posts_per_page']){
                                    // First page
                                    $new_link['url'] = sprintf($lang['viewtopic_topicid_title'], $topic['id'], clean_url_parameter($topic['title']));
                                }
                                else{
                                    // Not the first page
                                    $page_id  = intval(($posts_before - 1) / $board_config['posts_per_page']);
                                    $new_link['url'] = sprintf($lang['viewtopic_topicid_start_title'], $topic['id'], $page_id * $board_config['posts_per_page'], clean_url_parameter($topic['title']));
                                }
                            }
                        }
                    }
                    break; //switch($nb_of_params):case 1

                case 2: //switch($nb_of_params)
                    if(empty($parameters['t'])){
                        $new_link['url']    = $default;
                    }
                    else if(!empty($parameters['start'])){
                        $new_link['url']    = sprintf($lang['viewtopic_topicid_start_title'], $topic['id'], $parameters['start'], clean_url_parameter($topic['title']));
                    }
                    else if(!empty($parameters['watch']) and ($parameters['watch'] == 'topic')){
                        $new_link['url']    = sprintf($lang['watchtopic_id_title'], $topic['id'], clean_url_parameter($topic['title']));
                    }
                    else if(!empty($parameters['unwatch']) and ($parameters['unwatch'] == 'topic')){
                        $new_link['url']  = sprintf($lang['unwatchtopic_id_title'], $topic['id'], clean_url_parameter($topic['title']));
                    }
                    else if(!empty($parameters['postorder'])){
                        if(strtolower($parameters['postorder']) == 'asc'){
                            $new_link['url'] = sprintf($lang['viewtopic_topicid_title'], $topic['id'], clean_url_parameter($topic['title']));
                        }
                        else{
                            $new_link['url'] = sprintf($lang['viewtopic_topicid_desc_title'], $topic['id'], clean_url_parameter($topic['title']));
                        }
                    }
                    else if(!empty($highlight)){
                        $new_link['url']  = sprintf($lang['viewtopic_highlight_topicid_title'], $highlight, $topic['id'], clean_url_parameter($topic['title']));
                    }
                    else if(!empty($parameters['view'])){
                        //
                        // Here, we have the opportunity to display a meaningful link instead of the
                        // usual uninformative basic link
                        // This will have the advantage of not displaying two different links to the
                        // exact same page
                        //
                        switch($parameters['view']){
                            case 'previous': //switch($parameters['view'])
                                //
                                // This query more or less comes from viewtopic.php
                                //
                                $sql  = 'SELECT t.topic_id AS `id`, t.`topic_title` AS `title`
                                        FROM ' . TOPICS_TABLE . ' t
                                        INNER JOIN ' . TOPICS_TABLE . ' AS t2 ON t.forum_id = t2.forum_id
                                        WHERE t2.topic_id = '.$topic['id'].'
                                            AND t.topic_moved_id = 0
                                            AND t.topic_type = '.$topic['type'].'
                                            AND t.topic_last_post_id < t2.topic_last_post_id
                                        ORDER BY t.topic_last_post_id DESC
                                        LIMIT 1';
                                break; //switch($parameters['view']):case 'previous'

                            case 'next': //switch($parameters['view'])
                                //
                                // This query more or less comes from viewtopic.php
                                //
                                $sql  = 'SELECT t.topic_id AS `id`, t.`topic_title` AS `title`
                                        FROM ' . TOPICS_TABLE . ' t
                                        INNER JOIN ' . TOPICS_TABLE . ' AS t2 ON t.forum_id = t2.forum_id
                                        WHERE t2.topic_id = '.$topic['id'].'
                                            AND t.topic_moved_id = 0
                                            AND t.topic_type = '.$topic['type'].'
                                            AND t.topic_last_post_id > t2.topic_last_post_id
                                        ORDER BY t.topic_last_post_id
                                        LIMIT 1';
                                break; //switch($parameters['view']):case 'next'

                            case 'newest': //switch($parameters['view'])
//ToDo: look into this
                                /*$sql  = 'SELECT MAX(`topic_id`) AS `id`, `topic_title` AS `title`
                                        FROM `'.TOPICS_TABLE.'`
                                        WHERE `forum_id`='.$topic['forum_id'].'
                                            AND `topic_time` > '.$topic['time'].'
                                        GROUP BY `topic_title`
                                        LIMIT 1';*/
                                $sql  = 'SELECT p.post_id
                                        FROM ' . POSTS_TABLE . ' p
                                        INNER JOIN ' . USERS_TABLE . ' AS u ON p.poster_id=u.user_id
                                        INNER JOIN ' . SESSIONS_TABLE . ' AS s ON u.user_id = s.session_user_id
                                        WHERE s.session_id = '.$userdata['session_id'].'
                                            AND p.topic_id = '.$topic_id.'
                                            AND p.post_time >= u.user_lastvisit
                                        ORDER BY p.post_time
                                        LIMIT 1';
                                break; //switch($parameters['view']):case 'newest'

                            default: //switch($parameters['view']) -- This case should never happen
                                $sql = '';
                                break; //switch($parameters['view']):default
                        } //switch($parameters['view'])

                        if(empty($sql)){
                            $new_link['url'] = sprintf($lang['viewtopic_topicid_title'], $parameters['t'], clean_url_parameter($label));
                        }
                        else{
                            if(!($result   = $db->sql_query($sql))){
                                $new_link['url'] = $default;
                            }
                            else{
                                if($db->sql_numrows($result) != 1){
                                    // Special case: there is no previous or next topic --> it would be better
                                    // not to display any link but phpBB prefers to display it, so we will build
                                    // a link to the current page
                                    $new_link['url'] = $_SERVER['REQUEST_URI'];
                                }
                                else{
                                    if(($topic = $db->sql_fetchrow($result)) and !empty($topic['title'])){
                                        $new_link['url']    = sprintf($lang['viewtopic_topicid_title'], $topic['id'], clean_url_parameter($topic['title']));
                                    }
                                }
                            }
                        }
                    } //if(!empty($parameters['view']))
                    else{ // We have 2 parameters but we know only 't'
                        $new_link['url']  = $default;
                    } //else:if(!empty($parameters['view']))
                    break; //switch($nb_of_params):case 2

                case 3: //switch($nb_of_params)
                    if(!empty($parameters['t']) and !empty($parameters['start'])){
                        if(!empty($highlight)){
                            $new_link['url']  = sprintf($lang['viewtopic_topicid_highlight_start_title'], $topic['id'], $highlight, $parameters['start'], clean_url_parameter($topic['title']));
                        }
                        else if(!empty($parameters['postorder'])){
                            if(strtolower($parameters['postorder']) == 'asc'){
                                $new_link['url'] = sprintf($lang['viewtopic_topicid_start_title'], $topic['id'], $parameters['start'], clean_url_parameter($topic['title']));
                            }
                            else{
                                $new_link['url'] = sprintf($lang['viewtopic_topicid_desc_start_title'], $topic['id'], $parameters['start'], clean_url_parameter($topic['title']));
                            }
                        }
                        else if(!empty($parameters['watch']) and ($parameters['watch'] == 'topic')){
                            $new_link['url']  = sprintf($lang['watchtopic_id_start_title'], $topic['id'], $parameters['start'], clean_url_parameter($topic['title']));
                        }
                        else if(!empty($parameters['unwatch']) and ($parameters['watch'] == 'topic')){
                            $new_link['url']  = sprintf($lang['unwatchtopic_id_start_title'], $topic['id'], $parameters['start'], clean_url_parameter($topic['title']));
                        }
                        else{
                            $new_link['url']  = $default;
                        }
                    } //if(!empty($parameters['t']) and !empty($parameters['start']))
                    else{
                        $new_link['url']    = $default;
                    } //else:if(!empty($parameters['t']) and !empty($parameters['start']))
                    break; //switch($nb_of_params):case 3

                default: //switch($nb_of_params)
                    $new_link['url']    = $default;
                    break; //switch($nb_of_params):default
            } //switch($nb_of_params)
            break; //switch($old_link['file']):case 'viewtopic'


        default: //switch($old_link['file'])
            $new_link['url']    = $old_link['url']; // Default behaviour: let the original link as it is
            break;
    } //switch($old_link['file'])

    if($new_link['url'] != $new_link['url']){
        $new_link['url'] .= NEW_EXTENSION;
    }


    //
    // Add what I left out before (file extension and anchor)
    //
    if(($old_link['url'] != $new_link['url']) and (strpos($new_link['url'], NEW_EXTENSION) === FALSE)){
        if($old_link['path'] != './'){
            $new_link['url'] = $old_link['path'].$new_link['url'].NEW_EXTENSION.$old_link['anchor'];
        }
        else{
            $new_link['url'] = $new_link['url'].NEW_EXTENSION.$old_link['anchor'];
        }
    }

    return $new_link;
} //function rewrite_url()


/*
* Rewrite the URLs of a phpBB Web page
* @param    string $contents   The contents of the Web page
* @param    string $matches    The URLs of the Web page
* @param    string $link_type  'a', 'form', 'link rel', etc.
* @return   string             The rewritten contents of the whole page
*/
function rewrite_urls($contents, $matches, $link_type='a'){
    global $db, $userdata, $board_config, $phpbb_root_path, $phpEx; // Useful phpBB variables

    $patterns       = array();    // The link patterns will be added to this array
    $replacements   = array();    // The link replacements will be added to this array
    $websites_to_match = array(
        'http://'.$board_config['server_name'].$board_config['script_path'],
        SITE_FULL_URL);

    if(!empty($userdata['user_lang'])){
        $current_language = $userdata['user_lang'];
    }
    else{
        $current_language = $board_config['default_lang'];
    }

    include($phpbb_root_path.'/language/lang_'.$current_language.'/lang_urlrewrite.'.$phpEx);
    if(!is_array($lang)){
        return $contents;
    }

    //
    // This variable, $highlight, is a workaround for one small failure of the search.php script:
    // it does not display the 'highlight' parameter for every single link in the page,
    // although it should
    // My URL Rewriting actually fixes phpBB ;-)
    //
    $highlight = '';

    $i = 0; // Keeps track of the number of patterns/replacements we have found, used as the index in both the following arrays
    //
    // For each link found, split it into chunks (path, filename, parameters and anchor), then
    // figure out what new value we will assign
    //
    foreach($matches as $match){
        $match[2] = trim($match[2]);

        //
        // There are three kinds of links that we will not replace:
        //  -external links (they start with 'http://')
        //  -links used for other things than linking to a PHP script (i.e. used for JavaScript purposes)
        //  -links that we already processed during a previous loop
        // (Watch out, I reversed the tests in the actual code)
        //
        foreach($websites_to_match as $website_to_match){
            if(strpos($match[2], $website_to_match) !== FALSE){
                $match[2] = substr($match[2], strlen($website_to_match));
            }
        }

        if((strpos($match[2], 'http://') === FALSE)
            and strpos($match[2], $phpEx)
            and !in_array($match[0], $patterns))
        {
            $old_link = array();
            $new_link = array();

            $patterns[$i]    = $match[0];              // Save the original link for further global replacement
            $old_link['option_1']   = trim($match[1]); // There might be a class="" or any other option
            $old_link['url']        = str_replace('&amp;', '&', $match[2]);    // The link itself, including file name and parameters (and eventually the anchor)
            $old_link['option_2']   = trim($match[3]); // There might be a style="" or any other option

            if(!empty($match[4])){
                $old_link['label']  = $match[4];       // The name displayed for the link
            }
            else{
                $old_link['label']  = '';
            }

            //
            // This is just in case the forum produces HTML errors while building the links
            // (which phpBB does on some occasions: missing spaces)
            //
            if(empty($old_link['option_1'])){
                $old_link['option_1']    = ' ';
            }
            else{
                if($old_link['option_1']{0} != ' '){
                    $old_link['option_1']   = ' '.$old_link['option_1'];
                }

                if($old_link['option_1']{strlen($old_link['option_1'])-1} != ' '){
                    $old_link['option_1']   .= ' ';
                }
            }

            if(!empty($old_link['option_2']) and ($old_link['option_2']{0} != ' ')){
                $old_link['option_2']    = ' '.$old_link['option_2'];
            }


            //
            // Call the fonction to rewrite this one URL
            //
            $new_link = rewrite_url($old_link['url'], $lang['urlrewrite']);



            if(!empty($new_link['url']) and (strpos($old_link['option_1'].$old_link['option_2'], 'title=') === FALSE)){
                $old_link['option_2']    .= ' title="'.$lang['urlrewrite']['click_here'].' '.strip_tags($new_link['title']).'"';
            }

            // Replacement of the original link saved beforehand
            switch($link_type){
                case 'a':
                    $replacements[$i] = '<a'.$old_link['option_1'].'href="'.$new_link['url'].'"'.$old_link['option_2'].'>'.$old_link['label'].'</a>';
                    break;

                case 'form':
                    $replacements[$i] = '<form'.$old_link['option_1'].'action="'.$new_link['url'].'"'.$old_link['option_2'].'>';
                    break;

                case 'rdf:about':
                    $replacements[$i] = '<item rdf:about="'.SITE_FULL_URL.$new_link['url'].'">';
                    break;

                case 'rdf:resource':
                    $replacements[$i] = '<rdf:li rdf:resource="'.SITE_FULL_URL.$new_link['url'].'"/>';
                    break;

                case 'link':
                    $replacements[$i] = '<link>'.SITE_FULL_URL.$new_link['url'].'</link>';
                    break;

                case 'link rel':
                    $replacements[$i] = '<link rel'.trim($old_link['option_1']).' href="'.SITE_FULL_URL.$new_link['url'].'" '.trim($old_link['option_2']).'>';
                    break;

                case 'loc':
                    $replacements[$i] = '<loc>'.SITE_FULL_URL.$new_link['url'].'</loc>';
                    break;
            }
            ++$i;
        } //if((strpos($match[1], 'http://www.thisisnotawebsite.com/') or ...) ... and !in_array($match[0], $patterns))
    } //foreach($matches as $match)

    return str_replace($patterns, $replacements, $contents);
} //function rewrite_urls()

?>